'use strict';

var ListaNotificacaoController = angular.module('ListaNotificacaoController', []);

ListaNotificacaoController.controller('ListaNotificacaoCtrl', ['$scope', '$routeParams', '$location', 'Notificacao', 'CacheApp',
  ($scope, $routeParams, $location, Notificacao, CacheApp) => {
    
    $scope.setNotificacaoWeb = (notifConfig) => {
        var params = {
            IdNotificacaoConfig: notifConfig.IdNotificacaoConfig
        }

        if (notifConfig.Web) {
            notifConfig.Web = false
            // Verifica se o navegador suporta a API de Notificações
            if ('Notification' in window) {
                // Solicita permissão para exibir notificações
                Notification.requestPermission().then( (permission) => {
                    console.log(permission)
                    if (permission === 'granted') {
                        notifConfig.Web = true
                        if ('serviceWorker' in navigator && 'PushManager' in window) {
                            navigator.serviceWorker.register('./view/Notificacao/worker.js', {
                                scope: './view/Notificacao/'
                            }).then(
                                (register) => {
                                    console.log(register)
                                    register.pushManager.subscribe({
                                            userVisibleOnly: true,
                                            applicationServerKey: configVighaInit.publicVapidKey
                                    }).then(
                                        (subscription) => {
                                            console.log(subscription)
                                            params.Subscription = JSON.stringify(subscription)
                                            Notificacao.ativaNotificacaoWeb(params,(data) => {})
                                        },
                                        (err) => {
                                            console.log(err)
                                        }
                                    )
                                },
                                (err) => {
                                    console.log(err)
                                }
                            );
                        }
                    }

                });
            }
        }
        else
            Notificacao.desativaNotificacaoWeb(params,(data) => {})
    }

    $scope.setNotificacaoZap = (notifConfig) => {
        var params = {
            Subscription: $scope.sessao.Celular,
            IdNotificacaoConfig: notifConfig.IdNotificacaoConfig
        }

        if (notifConfig.Zap) {
            Notificacao.ativaNotificacaoZap(params,(data) => {})
        }
        else
            Notificacao.desativaNotificacaoZap(params,(data) => {})
    }

    $scope.getNotificacaoCliente = () => {
        Notificacao.getNotificacaoCliente(
            (data) => {
                $scope.listaNotificacao = data.Instance
                $scope.listaNotificacao.forEach(l => {
                    l.Data = CacheApp.getData(l.Data)
                })
            })
    }

    $scope.setTipoNotificacao = (item) => {
        var params = {
            IdCliente: $scope.sessao.IdCliente,
            IdTipoNotificacao: item.IdTipoNotificacao
        }
        if (item.check)
            Notificacao.ativaTipoNotificacao(params,(data) => {})
        else
            Notificacao.desativaTipoNotificacao(params,(data) => {})
    }

    $scope.getTipoNotificacao = () => {
        Notificacao.getTipoNotificacao(
            (data) => {
                // console.log(data.Instance)
                var acessos = $scope.sessao.AcessosObras
                $scope.listaTipoNotificacao = data.Instance.filter(c => acessos.some(a => a == c.Permissao));
                $scope.listaGrupo = []
                // console.log($scope.listaTipoNotificacao)
                $scope.listaTipoNotificacao.forEach(t => {
                        if (!$scope.listaGrupo.some(l => l.IdGrupoAcesso == t.IdGrupoAcesso))
                            $scope.listaGrupo.push({
                                IdGrupoAcesso: t.IdGrupoAcesso,
                                Nome: t.Grupo
                            })
                    }
                )
                
            })
    }

    $scope.notificationRedirect = (url) => {
        window.location.href = url
    }

    $scope.getNotificacaoConfig = (callBack) => {
        Notificacao.getNotificacaoConfig(
            (data) => {
                $scope.notifConfig = data.Instance
                callBack()
            });
    }

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.sessao = CacheApp.getSessao();
        $scope.getNotificacaoConfig(()=>{
            $scope.getNotificacaoCliente()
            $scope.getTipoNotificacao()
        })
    });
  
}]);
